Program FTPDemo;

Uses
    Crt, IP, Network, PktDrv, FTPSrv, Sockets;

Const
	MY_IP			= '128.128.1.217';
	MY_NETMASK		= '255.255.255.0';
	MY_GATEWAY		= '128.128.1.100';

Var
	IPHandle: Integer;
    Server: TFTPServer;
    IPConf: TIPAdapterConfig;
    Adapter: TPacketDriverAdapter;
begin
    ClrScr;

    // Create an Adapter object representing out network adapter.
    Adapter := TPacketDriverAdapter.Create;

    // If the adapter works fine, we bind the TCP/IP protocol.
    if Adapter.Status <> asOk then begin
        WriteLn('Could not initialise network adapter. PKTPM is not loaded.');
		Halt(2);
    end;
    IPConf.DHCP      := False;
	IPConf.IPAddress := IP_StringToAddr(MY_IP);
	IPConf.NetMask   := IP_StringToAddr(MY_NETMASK);
    IPConf.Gateway   := IP_StringToAddr(MY_GATEWAY);
    IPHandle         := IP_Init(Adapter, IPConf);
    if IPHandle = 0 then begin
        WriteLn('Could not initialise IP stack. Wrong Parameters.');
        Adapter.Free;
        Halt(3);
    end;

    Server := TFTPServer.Create;
    Write('Iniciando Server FTP... ');
    if Server.Start(INADDR_ANY, Swap(WORD(21)), 'C:\') then begin
        WriteLn('Iniciado.');
        Repeat NET_Work Until KeyPressed and (ReadKey = #27);
    end else begin
    	WriteLn('Error.');
    end;
    Server.Free;

    // Close everything
    IP_Deinit(IPHandle);
    Adapter.Free;
end.
